//*****************************************************************************
//*****************************************************************************
//  FILENAME: Master.h
//   Version: 2.00, Updated on 2013/5/19 at 10:43:43
//  Generated by PSoC Designer 5.4.2946
//
//  DESCRIPTION:  I2Cm User Module C Language interface file.
//-----------------------------------------------------------------------------
//      Copyright (c) Cypress Semiconductor 2013. All Rights Reserved.
//*****************************************************************************
//*****************************************************************************
#ifndef Master_INCLUDE
#define Master_INCLUDE

#include <m8c.h>

// Create pragmas to support proper argument and return value passing
#pragma fastcall16  Master_fReadBytes
#pragma fastcall16  Master_bWriteBytes
#pragma fastcall16  Master_bWriteCBytes
#pragma fastcall16  Master_Start
#pragma fastcall16  Master_Stop
#pragma fastcall16  Master_fSendStart
#pragma fastcall16  Master_fSendRepeatStart
#pragma fastcall16  Master_SendStop
#pragma fastcall16  Master_fWrite
#pragma fastcall16  Master_bRead

//-------------------------------------------------
// Prototypes of the Master API.
//-------------------------------------------------
// High leval commands
extern void  Master_Start(void);
extern BYTE  Master_fReadBytes(BYTE bSlaveAddr, BYTE * pbXferData, BYTE bCnt, BYTE bMode);
extern BYTE  Master_bWriteBytes(BYTE bSlaveAddr, BYTE * pbXferData, BYTE bCnt, BYTE bMode);
extern BYTE  Master_bWriteCBytes(BYTE bSlaveAddr, const BYTE * pcbXferData, BYTE bCnt, BYTE bMode);
extern void  Master_Stop(void);

// Low level commands
extern BYTE  Master_fSendStart(BYTE bSlaveAddr, BYTE fRW);
extern BYTE  Master_fSendRepeatStart(BYTE bSlaveAddr, BYTE fRW);
extern void  Master_SendStop(void);
extern BYTE  Master_fWrite(BYTE bData);
extern BYTE  Master_bRead(BYTE fACK);

//-------------------------------------------------
// Constants for Master API's.
//-------------------------------------------------
#define Master_CompleteXfer   0x00 // Perform a complete I2C transfer
#define Master_RepStart       0x01 // Perform a complete transfer with a Repeat Start
#define Master_NoStop         0x02 // Perform a complete transfer, but leave off the stop

#define Master_READ           0x01 // Set the R/W flag after the slave address.
#define Master_WRITE          0x00 // Clear the R/W flag after the slave address.

#define Master_XFER_ERROR     0x00 // Communication error with the slave.
#define Master_NAKslave       0x00 // NAK the slave after a read.
#define Master_ACKslave       0x01 // ACK the slave after a read.

#endif
// end of file Master.h
